Index: trunk/examples/extended/medical/fanoCavity2/essai.mac
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/essai.mac	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/essai.mac	(revision 1230)
@@ -1,20 +1,14 @@
-# $Id: essai.mac,v 1.3 2007/11/12 18:19:30 maire Exp $
+# $Id: essai.mac,v 1.5 2009/10/31 18:05:56 maire Exp $
 #
 /control/verbose 2
 /run/verbose 2
 #
-/testem/det/wallMater Water
-/testem/det/wallThickness 5 mm
-/testem/det/worldRadius   5 mm
+/testem/phys/addPhysics standard_opt3
 #
 /run/initialize
 #
-/process/inactivate msc
-/process/eLoss/fluct false
+/gun/energy 1 MeV
 #
-/gun/energy 10 keV
-/gun/direction 0 1 0
+/testem/event/printModulo 100000
 #
-/testem/event/printModulo 20000
-#
-#/run/beamOn 200000
+/run/beamOn 1000000
Index: trunk/examples/extended/medical/fanoCavity2/fanoCavity2.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/fanoCavity2.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/fanoCavity2.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: fanoCavity2.cc,v 1.2 2007/10/31 16:16:20 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/DetectorConstruction.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/DetectorConstruction.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/DetectorConstruction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorConstruction.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/DetectorMessenger.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/DetectorMessenger.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/DetectorMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/EventAction.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/EventAction.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/EventAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/EventActionMessenger.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/EventActionMessenger.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/EventActionMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/HistoManager.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/HistoManager.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/HistoManager.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: HistoManager.hh,v 1.3 2007/11/12 18:19:30 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/HistoMessenger.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/HistoMessenger.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/HistoMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: HistoMessenger.hh,v 1.2 2007/11/12 18:19:30 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/MyMollerBhabhaModel.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/MyMollerBhabhaModel.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/MyMollerBhabhaModel.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: MyMollerBhabhaModel.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
Index: trunk/examples/extended/medical/fanoCavity2/include/PhysicsList.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/PhysicsList.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/PhysicsList.hh	(revision 1230)
@@ -24,10 +24,7 @@
 // ********************************************************************
 //
+// $Id: PhysicsList.hh,v 1.2 2009/10/31 18:05:56 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
-// $Id: PhysicsList.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
-//
-// 
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -36,6 +33,8 @@
 #define PhysicsList_h 1
 
-#include "G4VUserPhysicsList.hh"
+#include "G4VModularPhysicsList.hh"
 #include "globals.hh"
+
+class G4VPhysicsConstructor;
 
 class DetectorConstruction;
@@ -44,28 +43,25 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
-class PhysicsList: public G4VUserPhysicsList
+class PhysicsList: public G4VModularPhysicsList
 {
-  public:
-    PhysicsList(DetectorConstruction*);
-   ~PhysicsList();
+public:
+  PhysicsList(DetectorConstruction*);
+  virtual ~PhysicsList();
 
-    // Construct particle and physics
-    void ConstructParticle();
-    void ConstructProcess();
- 
-    void SetCuts();
+  void ConstructParticle();
+        
+  void AddPhysicsList(const G4String& name);    
+  void ConstructProcess();    
+  void AddStepMax(); 
+  
+  void SetCuts();      
     
-    // these methods Construct physics processes and register them
-    void ConstructEM();
-    void AddStepMax();
-    
-    void SingleCoulombScattering (G4bool);    
-    void RegisterBrem (G4bool);
-    
-  private:
-    DetectorConstruction*  detector;
-    G4bool                 singleScattering;        
-    G4bool                 registerBrem;    
-    PhysicsListMessenger*  pMessenger;    
+private:
+
+  DetectorConstruction* detector;
+  PhysicsListMessenger* pMessenger; 
+
+  G4String emName;
+  G4VPhysicsConstructor*  emPhysicsList;
 };
 
@@ -74,4 +70,2 @@
 #endif
 
-
-
Index: trunk/examples/extended/medical/fanoCavity2/include/PhysicsListMessenger.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/PhysicsListMessenger.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/PhysicsListMessenger.hh	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: PhysicsListMessenger.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysicsListMessenger.hh,v 1.2 2009/10/31 18:05:56 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -33,10 +33,11 @@
 #define PhysicsListMessenger_h 1
 
+#include "G4UImessenger.hh"
 #include "globals.hh"
-#include "G4UImessenger.hh"
 
 class PhysicsList;
 class G4UIdirectory;
-class G4UIcmdWithABool;
+class G4UIcmdWithADoubleAndUnit;
+class G4UIcmdWithAString;
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -44,5 +45,6 @@
 class PhysicsListMessenger: public G4UImessenger
 {
-  public:  
+  public:
+  
     PhysicsListMessenger(PhysicsList* );
    ~PhysicsListMessenger();
@@ -50,9 +52,10 @@
     void SetNewValue(G4UIcommand*, G4String);
     
-  private:  
-    PhysicsList*        pPhysicsList;   
-    G4UIdirectory*      physDir;        
-    G4UIcmdWithABool*   singleScat;      
-    G4UIcmdWithABool*   brem;    
+  private:
+  
+    PhysicsList*               pPhysicsList;
+    
+    G4UIdirectory*             physDir;
+    G4UIcmdWithAString*        pListCmd;
 };
 
Index: trunk/examples/extended/medical/fanoCavity2/include/PrimaryGeneratorAction.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/PrimaryGeneratorAction.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/PrimaryGeneratorAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/ProcessesCount.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/ProcessesCount.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/ProcessesCount.hh	(revision 1230)
@@ -26,5 +26,5 @@
 //
 // $Id: ProcessesCount.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/RunAction.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/RunAction.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/RunAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: RunAction.hh,v 1.2 2007/10/31 16:16:20 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/StepMax.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/StepMax.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/StepMax.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMax.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/StepMaxMessenger.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/StepMaxMessenger.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/StepMaxMessenger.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMaxMessenger.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/SteppingAction.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/SteppingAction.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/SteppingAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingAction.hh,v 1.2 2007/10/31 16:16:20 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/SteppingVerbose.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/SteppingVerbose.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/SteppingVerbose.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: SteppingVerbose.hh,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/include/TrackingAction.hh
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/include/TrackingAction.hh	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/include/TrackingAction.hh	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: TrackingAction.hh,v 1.2 2007/10/31 16:16:20 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/run01.mac
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/run01.mac	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/run01.mac	(revision 1230)
@@ -1,6 +1,8 @@
-# $Id: run01.mac,v 1.2 2007/10/31 16:16:20 maire Exp $
+# $Id: run01.mac,v 1.3 2009/10/31 18:05:56 maire Exp $
 #
 /control/verbose 2
 /run/verbose 2
+#
+/testem/phys/addPhysics standard_opt3
 #
 /run/initialize
Index: trunk/examples/extended/medical/fanoCavity2/src/DetectorConstruction.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/DetectorConstruction.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/DetectorConstruction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorConstruction.cc,v 1.2 2007/11/05 13:19:16 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 
 //
Index: trunk/examples/extended/medical/fanoCavity2/src/DetectorMessenger.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/DetectorMessenger.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/DetectorMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: DetectorMessenger.cc,v 1.2 2007/11/05 13:19:16 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/src/EventAction.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/EventAction.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/EventAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventAction.cc,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/src/EventActionMessenger.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/EventActionMessenger.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/EventActionMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: EventActionMessenger.cc,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/src/HistoManager.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/HistoManager.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/HistoManager.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: HistoManager.cc,v 1.3 2007/11/12 18:19:30 maire Exp $
-// GEANT4 tag $Name:  $
+// $Id: HistoManager.cc,v 1.5 2008/09/28 16:15:39 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -54,6 +54,6 @@
  
   fileName[0] = "fanocavity2";
-  fileType    = "hbook";
-  fileOption  = "--noErrors uncompress";  
+  fileType    = "root";
+  fileOption  = "--noErrors export=root uncompress";  
   // histograms
   for (G4int k=0; k<MaxHisto; k++) {
@@ -224,5 +224,5 @@
  if (ih > MaxHisto) {
     G4cout << "---> warning from HistoManager::RemoveHisto() : histo " << ih
-           << "does not exist" << G4endl;
+           << "does not exist  (fac = " << fac << ")"  << G4endl;
     return;
   }
Index: trunk/examples/extended/medical/fanoCavity2/src/HistoMessenger.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/HistoMessenger.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/HistoMessenger.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: HistoMessenger.cc,v 1.2 2007/11/12 18:19:30 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/src/MyMollerBhabhaModel.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/MyMollerBhabhaModel.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/MyMollerBhabhaModel.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: MyMollerBhabhaModel.cc,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/src/PhysicsList.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/PhysicsList.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/PhysicsList.cc	(revision 1230)
@@ -24,9 +24,7 @@
 // ********************************************************************
 //
+// $Id: PhysicsList.cc,v 1.7 2009/10/31 18:05:01 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
-// $Id: PhysicsList.cc,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
-//
-
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -34,25 +32,47 @@
 #include "PhysicsList.hh"
 #include "PhysicsListMessenger.hh"
-#include "DetectorConstruction.hh"
+
+#include "PhysListEmStandard_option0.hh"
+#include "PhysListEmStandard_option3.hh"
+#include "PhysListEmStandard_GS.hh"
+#include "PhysListEmStandard_SS.hh"
+
+#include "StepMax.hh"
 
 #include "G4ParticleDefinition.hh"
-#include "G4ParticleTypes.hh"
-#include "G4ParticleTable.hh"
 
 #include "G4ProcessManager.hh"
 #include "G4LossTableManager.hh"
 
+// Bosons
+#include "G4ChargedGeantino.hh"
+#include "G4Geantino.hh"
+#include "G4Gamma.hh"
+
+// leptons
+#include "G4Electron.hh"
+#include "G4Positron.hh"
+
+// Hadrons
+#include "G4Proton.hh"
+
+
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
 
 PhysicsList::PhysicsList(DetectorConstruction* det)
-: G4VUserPhysicsList(), detector(det)
+: G4VModularPhysicsList(), detector(det)
 {
-  defaultCutValue = 10.*km;
-  singleScattering = false;
-  registerBrem = false;
-  pMessenger = new PhysicsListMessenger(this);
-  SetVerboseLevel(1);
+  G4LossTableManager::Instance();
+  pMessenger = new PhysicsListMessenger(this); 
+   
+  // EM physics
+  emName = G4String("standard_opt3");
+  emPhysicsList = new PhysListEmStandard_option3(emName,detector);
+      
+  defaultCutValue = 10*km;
+
+  SetVerboseLevel(1);  
   
-  G4LossTableManager::Instance();  
+  G4LossTableManager::Instance();
 }
 
@@ -60,5 +80,8 @@
 
 PhysicsList::~PhysicsList()
-{ delete pMessenger; }
+{
+  delete emPhysicsList;
+  delete pMessenger;  
+}
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -66,11 +89,17 @@
 void PhysicsList::ConstructParticle()
 {
+  // pseudo-particles
   G4Geantino::GeantinoDefinition();
+  G4ChargedGeantino::ChargedGeantinoDefinition();
+  
+  // gamma
   G4Gamma::GammaDefinition();
-
+  
+  // leptons
   G4Electron::ElectronDefinition();
   G4Positron::PositronDefinition();
 
-  G4Proton::ProtonDefinition();
+  // baryons
+  G4Proton::ProtonDefinition();  
 }
 
@@ -80,117 +109,10 @@
 {
   AddTransportation();
-  ConstructEM();
+  emPhysicsList->ConstructProcess();
+
   AddStepMax();
 }
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-#include "G4ComptonScattering.hh"
-#include "G4GammaConversion.hh"
-#include "G4PhotoElectricEffect.hh"
-
-#include "G4MultipleScattering.hh"
-#include "G4CoulombScattering.hh"
-
-#include "G4eIonisation.hh"
-#include "MyMollerBhabhaModel.hh"
-#include "G4eBremsstrahlung.hh"
-#include "G4eplusAnnihilation.hh"
-
-#include "G4hIonisation.hh"
-
-#include "G4EmProcessOptions.hh"
-#include "G4MscStepLimitType.hh"
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-
-void PhysicsList::ConstructEM()
-{
-  theParticleIterator->reset();
-  while( (*theParticleIterator)() ){
-    G4ParticleDefinition* particle = theParticleIterator->value();
-    G4ProcessManager* pmanager = particle->GetProcessManager();
-    G4String particleName = particle->GetParticleName();
-    G4int iAlong = 0, iPost = 0; 
-     
-    if (particleName == "gamma") {
-                 
-      pmanager->AddDiscreteProcess(new G4PhotoElectricEffect);
-      pmanager->AddDiscreteProcess(new G4ComptonScattering);         
-      pmanager->AddDiscreteProcess(new G4GammaConversion);
-      
-    } else if (particleName == "e-") {
-
-      if (singleScattering)
-        pmanager->AddProcess(new G4CoulombScattering,  -1, -1,       ++iPost);
-        else    
-        pmanager->AddProcess(new G4MultipleScattering, -1, ++iAlong, ++iPost);
-      
-      G4eIonisation* eIoni = new G4eIonisation();
-      eIoni->SetEmModel(new MyMollerBhabhaModel);             
-      pmanager->AddProcess(eIoni,                      -1, ++iAlong, ++iPost);
-      
-      if (registerBrem)
-        pmanager->AddProcess(new G4eBremsstrahlung,    -1, ++iAlong, ++iPost);      
-       
-    } else if (particleName == "e+") {
-    
-      if (singleScattering)
-        pmanager->AddProcess(new G4CoulombScattering,  -1, -1,       ++iPost);
-        else   
-        pmanager->AddProcess(new G4MultipleScattering, -1, ++iAlong, ++iPost);
-      
-      G4eIonisation* pIoni = new G4eIonisation();
-      pIoni->SetEmModel(new MyMollerBhabhaModel);                   
-      pmanager->AddProcess(pIoni,                      -1, ++iAlong, ++iPost);
-      
-      if (registerBrem) {
-        pmanager->AddProcess(new G4eBremsstrahlung,    -1, ++iAlong, ++iPost);
-        pmanager->AddProcess(new G4eplusAnnihilation,   0, -1,       ++iPost);
-      }
-      
-    } else if (particleName == "proton") {
-    
-      if (singleScattering)
-        pmanager->AddProcess(new G4CoulombScattering,  -1, -1,       ++iPost);
-        else   
-        pmanager->AddProcess(new G4MultipleScattering, -1, ++iAlong, ++iPost);
-	
-      pmanager->AddProcess(new G4hIonisation,          -1, ++iAlong, ++iPost);
-    }
-  }
-  
-  // Em options
-  //
-  G4EmProcessOptions emOptions;
-  
-  //multiple scattering
-  //
-  emOptions.SetMscStepLimitation(fUseDistanceToBoundary);
-  emOptions.SetSkin(2.);
-  
-  //physics tables
-  //
-  emOptions.SetMinEnergy(100*eV);    
-  emOptions.SetMaxEnergy(10*GeV);  
-  emOptions.SetDEDXBinning(800);  
-  emOptions.SetLambdaBinning(800);
-  
-  //energy loss
-  //  
-  emOptions.SetStepFunction(0.2, 10*um);
-  emOptions.SetLinearLossLimit(1.e-6);
-          
-  //build CSDA range
-  //
-  emOptions.SetBuildCSDARange(true);
-  emOptions.SetMaxEnergyForCSDARange(10*GeV);  
-  emOptions.SetDEDXBinningForCSDARange(800);    
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-#include "StepMax.hh"
 
 void PhysicsList::AddStepMax()
@@ -204,8 +126,49 @@
       G4ProcessManager* pmanager = particle->GetProcessManager();
 
-      if (stepMaxProcess->IsApplicable(*particle))
+      if (stepMaxProcess->IsApplicable(*particle) && !particle->IsShortLived())
         {
 	  pmanager ->AddDiscreteProcess(stepMaxProcess);
         }
+  }
+}
+
+//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
+
+void PhysicsList::AddPhysicsList(const G4String& name)
+{
+  if (verboseLevel>-1) {
+    G4cout << "PhysicsList::AddPhysicsList: <" << name << ">" << G4endl;
+  }
+
+  if (name == emName) return;
+
+  if (name == "standard_opt0") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new PhysListEmStandard_option0(name,detector);
+    
+  } else if (name == "standard_opt3") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new PhysListEmStandard_option3(name,detector);
+    
+  } else if (name == "standard_GS") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new PhysListEmStandard_GS(name,detector);    
+    
+  } else if (name == "standard_SS") {
+
+    emName = name;
+    delete emPhysicsList;
+    emPhysicsList = new PhysListEmStandard_SS(name,detector);    
+  } else {
+
+    G4cout << "PhysicsList::AddPhysicsList: <" << name << ">"
+           << " is not defined"
+           << G4endl;
   }
 }
@@ -227,23 +190,6 @@
   SetCutValue(defaultCutValue, "e-");
   SetCutValue(defaultCutValue, "e+");
+  SetCutValue(defaultCutValue, "proton");  
 }
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-void PhysicsList::SingleCoulombScattering(G4bool flag)
-{
-  singleScattering = flag;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-void PhysicsList::RegisterBrem(G4bool flag)
-{
-  registerBrem = flag;
-}
-
-//....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
-
-
-
-
Index: trunk/examples/extended/medical/fanoCavity2/src/PhysicsListMessenger.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/PhysicsListMessenger.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/PhysicsListMessenger.cc	(revision 1230)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: PhysicsListMessenger.cc,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// $Id: PhysicsListMessenger.cc,v 1.2 2009/10/31 18:05:01 maire Exp $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -34,5 +34,6 @@
 #include "PhysicsList.hh"
 #include "G4UIdirectory.hh"
-#include "G4UIcmdWithABool.hh"
+#include "G4UIcmdWithADoubleAndUnit.hh"
+#include "G4UIcmdWithAString.hh"
 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
@@ -40,19 +41,12 @@
 PhysicsListMessenger::PhysicsListMessenger(PhysicsList* pPhys)
 :pPhysicsList(pPhys)
-{
+{ 
   physDir = new G4UIdirectory("/testem/phys/");
   physDir->SetGuidance("physics list commands");
-  
-  singleScat = new G4UIcmdWithABool("/testem/phys/singleScattering",this);
-  singleScat->SetGuidance("apply single Coulomb scattering process");
-  singleScat->SetParameterName("flag",true);
-  singleScat->SetDefaultValue(true);
-  singleScat->AvailableForStates(G4State_PreInit);
-        
-  brem = new G4UIcmdWithABool("/testem/phys/registerBrem",this);
-  brem->SetGuidance("register Brems in PhysicsList");
-  brem->SetParameterName("flag",true);
-  brem->SetDefaultValue(true);
-  brem->AvailableForStates(G4State_PreInit);    
+
+  pListCmd = new G4UIcmdWithAString("/testem/phys/addPhysics",this);  
+  pListCmd->SetGuidance("Add modula physics list.");
+  pListCmd->SetParameterName("PList",false);
+  pListCmd->AvailableForStates(G4State_PreInit);
 }
 
@@ -61,7 +55,6 @@
 PhysicsListMessenger::~PhysicsListMessenger()
 {
-  delete singleScat;
-  delete brem;
-  delete physDir;    
+  delete pListCmd;
+  delete physDir;
 }
 
@@ -70,10 +63,7 @@
 void PhysicsListMessenger::SetNewValue(G4UIcommand* command,
                                           G4String newValue)
-{  
-  if (command == singleScat)
-   {pPhysicsList->SingleCoulombScattering(singleScat->GetNewBoolValue(newValue));}
-            
-  if (command == brem)
-   {pPhysicsList->RegisterBrem(brem->GetNewBoolValue(newValue));}      
+{           
+  if( command == pListCmd )
+   { pPhysicsList->AddPhysicsList(newValue);}
 }
 
Index: trunk/examples/extended/medical/fanoCavity2/src/PrimaryGeneratorAction.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/PrimaryGeneratorAction.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/PrimaryGeneratorAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: PrimaryGeneratorAction.cc,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/src/RunAction.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/RunAction.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/RunAction.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: RunAction.cc,v 1.3 2007/11/05 13:19:16 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 // 
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
Index: trunk/examples/extended/medical/fanoCavity2/src/StepMax.cc
===================================================================
--- trunk/examples/extended/medical/fanoCavity2/src/StepMax.cc	(revision 1187)
+++ trunk/examples/extended/medical/fanoCavity2/src/StepMax.cc	(revision 1230)
@@ -25,5 +25,5 @@
 //
 // $Id: StepMax.cc,v 1.1 2007/10/15 16:20:23 maire Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-03-cand-01 $
 //
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo......
